@echo off
if [%1]==[] goto :error

echo   Extracting files...

cd %~dp0

.\bin\7z -y x "%~f1" -oISO > nul
if errorlevel 1 goto :generror
move /y .\ISO\PSP_GAME\INSDIR\RES.DAT .\ISO\PSP_GAME\INSDIR\RES.old > nul
move /y .\ISO\PSP_GAME\USRDIR\first.dat .\ISO\PSP_GAME\USRDIR\first.old > nul
move /y .\ISO\PSP_GAME\USRDIR\envpsp.dat .\ISO\PSP_GAME\USRDIR\envpsp.old > nul
move /y .\ISO\PSP_GAME\SYSDIR\EBOOT.BIN .\ISO\PSP_GAME\SYSDIR\EBOOT.old > nul
move /y .\ISO\PSP_GAME\PARAM.SFO .\ISO\PSP_GAME\PARAM.old > nul
move /y .\ISO\PSP_GAME\INSDIR\ICON0.PNG .\ISO\PSP_GAME\INSDIR\ICON0.old > nul
move /y .\ISO\PSP_GAME\INSDIR\PIC1.PNG .\ISO\PSP_GAME\INSDIR\PIC1.old > nul
move /y .\ISO\PSP_GAME\PIC1.PNG .\ISO\PSP_GAME\PIC1.old > nul

echo   Patching files...

.\bin\xdelta.exe -d -s .\ISO\PSP_GAME\INSDIR\RES.old .\files\RES.patch .\ISO\PSP_GAME\INSDIR\RES.DAT
if errorlevel 1 goto :patcherror
.\bin\xdelta.exe -d -s .\ISO\PSP_GAME\USRDIR\first.old .\files\first.patch .\ISO\PSP_GAME\USRDIR\first.dat
if errorlevel 1 goto :patcherror
.\bin\xdelta.exe -d -s .\ISO\PSP_GAME\USRDIR\envpsp.old .\files\envpsp.patch .\ISO\PSP_GAME\USRDIR\envpsp.dat
if errorlevel 1 goto :patcherror
.\bin\xdelta.exe -d -s .\ISO\PSP_GAME\USRDIR\libfont.prx .\files\font.patch .\ISO\PSP_GAME\USRDIR\font.pgf
if errorlevel 1 goto :patcherror
.\bin\xdelta.exe -d -s .\ISO\PSP_GAME\SYSDIR\EBOOT.old .\files\EBOOT.patch .\ISO\PSP_GAME\SYSDIR\EBOOT.BIN
if errorlevel 1 goto :patcherror
.\bin\xdelta.exe -d -s .\ISO\PSP_GAME\PARAM.old .\files\PARAM.patch .\ISO\PSP_GAME\PARAM.SFO >nul 2>&1
if errorlevel 1 move /y .\ISO\PSP_GAME\PARAM.old .\ISO\PSP_GAME\PARAM.SFO > nul
.\bin\xdelta.exe -d -s .\ISO\PSP_GAME\INSDIR\ICON0.old .\files\ICON0.patch .\ISO\PSP_GAME\INSDIR\ICON0.PNG
if errorlevel 1 goto :patcherror
.\bin\xdelta.exe -d -s .\ISO\PSP_GAME\INSDIR\PIC1.old .\files\PIC1.patch .\ISO\PSP_GAME\INSDIR\PIC1.PNG
if errorlevel 1 goto :patcherror
.\bin\xdelta.exe -d -s .\ISO\PSP_GAME\PIC1.old .\files\PIC1.patch .\ISO\PSP_GAME\PIC1.PNG
if errorlevel 1 goto :patcherror

del .\ISO\PSP_GAME\INSDIR\RES.old >nul
del .\ISO\PSP_GAME\USRDIR\first.old >nul
del .\ISO\PSP_GAME\USRDIR\envpsp.old >nul
del .\ISO\PSP_GAME\SYSDIR\EBOOT.old >nul
del .\ISO\PSP_GAME\PARAM.old >nul 2>&1
del .\ISO\PSP_GAME\INSDIR\ICON0.old >nul
del .\ISO\PSP_GAME\INSDIR\PIC1.old >nul
del .\ISO\PSP_GAME\PIC1.old >nul

echo   Creating ISO...

.\bin\mkisofs -quiet -iso-level 4 -xa -A "PSP GAME" -V "OreImo" -sysid "PSP GAME" -volset "OreImo" -p "" -publisher "" -o "OreImo Tsuzuku Disc 2 English.iso" ISO/ 2>nul
if errorlevel 1 goto :generror
echo   Patching completed.

goto :end

:generror
echo.
echo Unknown error.
goto :end

:patcherror
echo.
echo Invalid patch input.
echo Make sure your game ISO is correct.
goto :end

:error
echo.
echo Incorrect patch usage.
echo Please drag and drop your original ISO over patch.bat
echo instead of double clicking.
goto :end

:end
echo.
rmdir /Q /S ISO
pause